﻿Option Strict On
Option Explicit On

Imports System.Web.HttpContext
Imports System.Net
Imports System.IO
Imports System.Xml

Public Class smsSender

    ' *
    ' * Copyright (c) 2012, Dinahosting S.L.
    ' * All rights reserved.
    ' * 
    ' * Redistribution and use in source and binary forms, with or without modification,
    ' * are permitted provided that the following conditions are met:
    ' * 
    ' *     * Redistributions of source code must retain the above copyright notice, this
    ' *       list of conditions and the following disclaimer.
    ' *     * Redistributions in binary form must reproduce the above copyright notice,
    ' *       this list of conditions and the following disclaimer in the documentation
    ' *       and/or other materials provided with the distribution.
    ' *     * Neither the name of the Dinahosting S.L. nor the names of its contributors
    ' *       may be used to endorse or promote products derived from this software
    ' *       without specific prior written permission.
    ' * 
    ' * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
    ' * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
    ' * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
    ' * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
    ' * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
    ' * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
    ' * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
    ' * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
    ' * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
    ' * OF THE POSSIBILITY OF SUCH DAMAGE.
    ' */

    'Response.Expires = -1
    'Response.Buffer=True 

    '    Inherits System.Web.UI.Page

    Public Errores() As String
    Public Credito As Integer
    Public usuario, password As String

    '/**
    ' * url a la que se envian las peticiones.
    ' */
    Const DINAHOSTING_URL_ENVIO As String = "https://apisms.gestiondecuenta.com/php/comun/ejecutarComando.php"

    '/**
    ' * Para ayudar al depurado.
    ' */
    Const DINAHOSTING_SMS_DEBUG As Boolean = True


    ' **
    ' * Creamos el objet con los datos de la cuenta.
    ' *
    ' */
    Public Sub New(ByVal cuenta As String, ByVal passw As String)
        usuario = cuenta
        password = passw
    End Sub

    ' **
    ' * Obtiene el crédito restante
    ' * devuelve:
    ' *			|->entero
    ' */
    Friend Function DHgetCredito() As Object
        Dim num_errores As Integer
        Dim xmlTXT As String = ObtenerXML("command=sms_getCredit")

        'errores
        num_errores = CInt(ParsearXML(xmlTXT, "interface-response", "ErrCount"))

        'OK
        If num_errores = 0 Then
            Credito = CInt(ParsearXML(xmlTXT, "interface-response", "smsCredit").Replace(".", ","))
            Return Credito
        Else
            'KO
            ObtenerErrores(xmlTXT, num_errores)
            Return False
        End If
    End Function

    ' **
    ' * Envía un sms a 1 destinatario.
    ' * parámetros:
    ' *			|->numero: string
    ' *			|->mensaje: string
    ' * devuelve:
    ' *			|->boolean
    ' */
    Friend Function DHSend(ByVal numero As String, ByVal mensaje As String, ByVal remite As String) As Boolean
        Dim num_errores As Integer
        Dim xmlTXT, parametros As String

        parametros = "command=sms_send&sms=" & mensaje & "&sms_to=" & numero
        If remite <> "" Then
            parametros &= "&remite=" & remite
        End If

        xmlTXT = ObtenerXML(parametros)

        'errores
        num_errores = CInt(ParsearXML(xmlTXT, "interface-response", "ErrCount"))

        'OK
        If num_errores = 0 Then
            Credito = CInt(ParsearXML(xmlTXT, "interface-response", "smsCredit").Replace(".", ","))
            Return True
        Else
            'KO
            ObtenerErrores(xmlTXT, num_errores)
            Return False
        End If
    End Function

    ' **
    ' * Envía un sms a varios destinatarios.
    ' * parámetros:
    ' *			|->numero: array  
    ' *			|->mensaje: string
    ' * devuelve:
    ' *			|->boolean
    ' */
    Friend Function DHSendBulk(ByVal numero() As String, ByVal mensaje As String, ByVal remite As String) As Boolean
        Dim i, num_errores As Integer
        Dim xmlTXT, parametros As String

        parametros = "command=sms_sendBulk" & "&sms=" & mensaje

        For i = LBound(numero) To UBound(numero)
            parametros &= "&sms_to[" & i + 1 & "]=" & numero(i)
        Next
        parametros &= "&sms_n_msgs=" & i
        If remite <> "" Then
            parametros &= "&remite=" & remite
        End If

        xmlTXT = ObtenerXML(parametros)

        'errores
        num_errores = CInt(ParsearXML(xmlTXT, "interface-response", "ErrCount"))

        'OK
        If num_errores = 0 Then
            Credito = CInt(ParsearXML(xmlTXT, "interface-response", "smsCredit").Replace(".", ","))
            Return True
        Else
            'KO
            ObtenerErrores(xmlTXT, num_errores)
            Return False
        End If
    End Function

    ' **
    ' * Realiza la petición remota.
    ' */
    Private Function ObtenerXML(ByVal parametros As String) As String
        ' Especifica la URL
        Dim req As HttpWebRequest = DirectCast(WebRequest.Create(DINAHOSTING_URL_ENVIO), HttpWebRequest)
        ' Conexión
        req.Method = "POST"
        req.ContentType = "application/x-www-form-urlencoded"
        req.Headers.Add("Accept-Language", "sp")
        req.Headers.Add("Pragma", "no-cache")
        req.Headers.Add("charset", "iso-8859-1")

        If DINAHOSTING_SMS_DEBUG Then
            Current.Response.Write("POST " & DINAHOSTING_URL_ENVIO & "<BR>")
            Current.Response.Write("Post data: '" & parametros & "'" & "<BR>")
        End If

        ' Enviar y obtener datos
        Dim requestWriter2 As New StreamWriter(req.GetRequestStream())
        requestWriter2.Write("cuenta=" & usuario & "&password=" & password & "&" & parametros)
        requestWriter2.Close()

        Dim resp As HttpWebResponse = DirectCast(req.GetResponse(), HttpWebResponse)
        Dim responseReader As New StreamReader(resp.GetResponseStream())
        Dim TheData As String = responseReader.ReadToEnd()

        If DINAHOSTING_SMS_DEBUG Then
            Current.Response.Write("Respuesta: " & Current.Server.HtmlEncode(TheData) & "<BR>")
        End If

        Return TheData
    End Function

    ' **
    ' * parsea XML
    ' */
    Private Function ParsearXML(ByVal XML As String, ByVal nodo As String, ByVal valor As String) As String
        Dim xmldoc As New XmlDocument()
        xmldoc.LoadXml(XML)
        Dim valor_nodo As XmlNode = xmldoc.SelectSingleNode(nodo & "/" & valor)
        Dim valorLeido As String = valor_nodo.InnerText
        xmldoc = Nothing
        valor_nodo = Nothing
        Return valorLeido
    End Function

    Private Sub ObtenerErrores(xmlTXT As String, num_errores As Integer)
        Dim i As Integer
        ReDim Errores(num_errores)
        For i = 1 To num_errores
            Errores(i - 1) = DirectCast(ParsearXML(xmlTXT, "interface-response/errors", "Err" & i), String)
        Next
    End Sub

End Class
